(********************************************************************
 * COPYRIGHT --  
 ********************************************************************
 * Program: MachineProg
 * File: PiperModuleInterface.st
 * Author: Josh
 * Created: October 03, 2013
 ********************************************************************
 * Implementation of program MachineProg
 ********************************************************************) 

// PiperModuleInterface.st
ACTION PiperModuleInterface:

    //Give this module a name so it is easier to debug
	ModuleInterface.ModuleName:=    'Piper Example';

	//Add a module to the Piper
	Module.ModuleInterface:=    ADR(ModuleInterface);
	Module.Piper:=  ADR(gMachine);
	Module();

	// Handle any machine states that this module needs to respond to
	CASE ModuleInterface.PiperState OF
		MACH_ST_STARTING:
			// Enable heating element
			heatOn := TRUE;
			
			// Wait to reach temperature
			IF temperature > 70 THEN
				ModuleInterface.ModuleResponse:=    ModuleInterface.PiperState;
			END_IF
			
		MACH_ST_EXECUTE:
			
			// Check for overtemperatur condition
			IF temperature > 100 THEN
				// Abort operation
				gMachine.IN.CMD.Abort := TRUE;
			END_IF
			
			// Do not hold up this states
			ModuleInterface.ModuleResponse:=    ModuleInterface.PiperState;
		
		MACH_ST_COMPLETING,
		MACH_ST_STOPPING,
		MACH_ST_ABORTING:
			
			// Disable heating element
			heatOn := FALSE;
			
			// Do not hold up these states
			ModuleInterface.ModuleResponse:=    ModuleInterface.PiperState;
		
		//      MACH_ST_BOOTING:        
		//      MACH_ST_CLEARING:
		//      MACH_ST_STOPPED:
		//      MACH_ST_IDLE:
		//      MACH_ST_SUSPENDED:
		//      MACH_ST_ABORTED:
		//      MACH_ST_HOLDING:
		//      MACH_ST_HELD:
		//      MACH_ST_UNHOLDING:
		//      MACH_ST_SUSPENDING:
		//      MACH_ST_UNSUSPENDING:
		//      MACH_ST_RESETTING:
	
		//      MACH_ST_COMPLETE:
        
		MACH_ST_BYPASSED:
        
		ELSE
			ModuleInterface.ModuleResponse:=    ModuleInterface.PiperState;
        
	END_CASE

END_ACTION
